
import java.util.*;

class NessunDipendente extends Exception {}
class DipendenteEsistente extends Exception {}

class Dipendente {
    
    private int codice;
    private String cognome;
    private String nome;
    
    public Dipendente(int codice, String cognome, String nome) {
        this.codice = codice;
        this.cognome = cognome;
        this.nome = nome;
    }

    public int getCodice() {
        return codice;
    }

    public String getCognome() {
        return cognome;
    }

    public String getNome() {
        return nome;
    }
}


public class Dipendenti {
    
private TreeMap<Integer, Dipendente> elenco;

    public Dipendenti() {
        elenco = new TreeMap<Integer, Dipendente>();
    }
    
    public void aggiungiDipendente(int codice, String cognome, String nome) throws DipendenteEsistente {
        Dipendente tmp = new Dipendente(codice, cognome, nome);
        
        if (elenco.containsKey(codice)) throw new DipendenteEsistente();
        elenco.put(codice, tmp);
    }
    
    public Dipendente trovaDipendente(int codice) throws NessunDipendente {
        Dipendente tmp = elenco.get(codice);
        
        if (tmp == null) throw new NessunDipendente();
        return tmp;
    }
    
    public void rimuoviDipendente(int codice) throws NessunDipendente {
        if (elenco.containsKey(codice))
            elenco.remove(codice);
        else        
            throw new NessunDipendente();
    }
}
